<template>
  <div class="relative">
    <div
        class="flex items-center cursor-pointer mb-3"
        @click="tagsPreferencesProvider.shown = !tagsPreferencesProvider.shown"
    >
      <h3 class="text-yellow-600 font-bold text-lg">
        Vos préferences pour les {{ tagsPreferencesProvider.textByType }}
      </h3>
      <div
          class="ml-5 hover:bg-gray-400 rounded-full p-2 h-8 w-8 grid justify-items-center"
      >
        <font-awesome-icon
            :icon="tagsPreferencesProvider.shown ? 'angle-down' : 'angle-right'"
        />
      </div>
    </div>
    <div v-show="tagsPreferencesProvider.shown">
      <input
          v-model="tagsPreferencesProvider.search"
          type="text"
          class="appearance-none rounded-none relative block w-full px-3 py-3 border border-gray-300 placeholder-gray-500 text-gray-900 rounded-t-md focus:outline-none focus:ring-yellow-500 focus:border-yellow-500 focus:z-10 sm:text-sm"
          placeholder="Rechercher des catégories..."
          @input="tagsPreferencesProvider.onInputSearch($event.target.value)"
          @click.stop="tagsPreferencesProvider.onInputClick($event.target.value)"
          v-click-outside="tagsPreferencesProvider.onClickOutsideInput"
      />
      <div v-show="tagsPreferencesProvider.foundResults !== null">
        <ul
            class="absolute z-50 bg-white rounded shadow-xl w-full border border-yellow-600 max-h-40 overflow-y-auto"
        >
          <li
              v-show="
              tagsPreferencesProvider.foundResults !== null &&
              tagsPreferencesProvider.foundResults.length === 0
            "
              class="block px-4 py-2 hover:bg-yellow-500 hover:text-white"
          >
            Aucun résulat
          </li>

          <li
              :key="elem"
              v-for="elem in tagsPreferencesProvider.foundResults
              ? tagsPreferencesProvider.foundResults
              : []"
              class="block px-4 py-2 hover:bg-yellow-500 hover:text-white"
              @click="tagsPreferencesProvider.addPreference(elem)"
          >
            {{ translation.displayTagOrCategory(elem, tagsPreferencesProvider.type === 'hostel' ? 'category' : 'tag').toUpperCase() }}
            <hr/>
          </li>
        </ul>
      </div>
      <div
          v-show="tagsPreferencesProvider.preferences.length > 0"
          class="flex items-center flex-wrap"
      >
        <div
            :key="index"
            v-for="(tag, index) of tagsPreferencesProvider.preferences"
            class="flex my-2"
        >
          <div
              :class="
              'py-2 px-4 rounded-full mr-2 ' +
              (tagsPreferencesProvider.searchedButAlreadyPresent === tag
                ? 'bg-red-500'
                : 'bg-yellow-500')
            "
          >
            <span
                class="cursor-default text-white font-bold"
                :title="
                tagsPreferencesProvider.type === 'hostel'
                  ? 'Synonymes :\n' +
                    translation.getHostelSynonyms(tag).join('\n')
                  : ''
              "
            >
              {{ translation.displayTagOrCategory(tag, tagsPreferencesProvider.type === 'hostel' ? 'category' : 'tag').toUpperCase() }}
            </span>
            <font-awesome-icon
                icon="times-circle"
                class="ml-2 cursor-pointer text-white"
                @click="tagsPreferencesProvider.removePreference(tag)"
            />
          </div>
        </div>
      </div>
      <div v-show="tagsPreferencesProvider.preferences.length === 0">
        <h4 class="text-md my-3">Toutes les catégories</h4>
      </div>
      <div class="my-4">
        <a
            v-if="tagsPreferencesProvider.field === null"
            @click="tagsPreferencesProvider.savePreferences()"
            :class="
              'p-3 rounded-xl bg-yellow-500  ' +
              (tagsPreferencesProvider.saved
                ? 'text-gray-500 cursor-default'
                : 'hover:bg-yellow-600 cursor-pointer')
            "
        >
          Sauvegarder
        </a>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "TagsPreferences",
  inject: ["tagsPreferencesProvider", "user","translation"],
};
</script>

<style scoped></style>
